//------------------------------------------------------------------------------
//
//   Greg's Blocks - ItemShape - Client
//
//------------------------------------------------------------------------------

package gcewing.blocks;

import java.util.List;
import java.util.ArrayList;
import java.util.Random;

import net.minecraft.block.*;
import net.minecraft.client.renderer.texture.*;
import net.minecraft.entity.player.*;
import net.minecraft.init.*;
import net.minecraft.item.*;
import net.minecraft.nbt.*;
import net.minecraft.world.*;
import net.minecraft.util.StatCollector;

public class ItemShape extends ItemBlock {

	static Random rand = new Random();
	
	public ItemShape(Block block) {
		super(block);
	}
	
	@Override
	public void registerIcons(IIconRegister reg) {
	}

	@Override
	public boolean onItemUse(ItemStack stack, EntityPlayer player, World world,
		int x, int y, int z, int face, float par8, float par9, float par10)
	{
		//System.out.printf("ItemShape.onItemUse\n");
		if (super.onItemUse(stack, player, world, x, y, z, face, par8, par9, par10)) {
			TEShape te = BlockShape.lastPlacedTileEntity;
			if (te != null) {
				NBTTagCompound tag = stack.getTagCompound();
				if (tag != null) {
					//System.out.printf("ItemShape.onItemUse: initialising TEShape\n");
					te.readShapeFromNBT(tag);
				}
			}
			return true;
		}
		return false;
	}

	@Override
	public boolean getShareTag() {
		return true;
	}

	@Override
	public void addInformation(ItemStack stack, EntityPlayer player, List lines, boolean par4) {
		NBTTagCompound tag = stack.getTagCompound();
		if (tag != null) {
			int shape = tag.getInteger("Shape");
			Block baseBlock = Block.getBlockFromName(tag.getString("BaseName"));
			int baseMetadata = tag.getInteger("BaseData");
			if (shape >= 0 && shape < TEShape.numShapes)
				lines.set(0, TEShape.shapeNames[shape]);
			else
				lines.set(0, lines.get(0) + " (" + shape + ")");
			if (baseBlock != null) {
				String baseName = null;
				Item baseItem = Item.getItemFromBlock(baseBlock);
				if (baseItem != null) {
					ItemStack baseStack = new ItemStack(baseItem, 1, baseMetadata);
					baseName = baseStack.getDisplayName();
				}
				if (baseName == null)
					baseName = baseBlock.getLocalizedName();
				String template = StatCollector.translateToLocal("text.gcewing_blocks:cutFrom");
				//String desc = "Cut from " + baseName;
				String desc = String.format(template, baseName);
				lines.add(desc);
			}
		}
	}

}
